
#if !defined(Helpers_h)
#define Helpers_h

#define FILE_LINE \
  FileLine(__FILE__, __LINE__)
struct FileLine {
  FileLine() : file_("default file"), line_(0) {}
  FileLine(char const *file, int line) : file_(file), line_(line) {}
  char const *file_;
  int line_;
};

/** Abstract class for iterating over some value set.
  */
template<typename T>
class IIterator {
  public:
    virtual bool More() = 0;
    virtual T Next() = 0;
    virtual void Dispose() = 0;
};

template<typename T> struct deref {
  typedef T type;
};
template<typename T> struct deref<T &> {
  typedef T type;
};
template<typename T> struct deconst {
  typedef T type;
};
template<typename T> struct deconst<T const> {
  typedef T type;
};


#endif
